filter-branch: Export variable `workdir' for --commit-filter
[git/git.git] / git-filter-branch.sh
CommitLineData
6f6826c5
JS
1#!/bin/sh
2#
3# Rewrite revision history
4# Copyright (c) Petr Baudis, 2006
5# Minimal changes to "port" it to core-git (c) Johannes Schindelin, 2007
6#
c401b33c
JS
7# Lets you rewrite the revision history of the current branch, creating
8# a new branch. You can specify a number of filters to modify the commits,
9# files and trees.
6f6826c5 10
16ed34ad
JS
11# The following functions will also be available in the commit filter:
12
13functions=$(cat << \EOF
b5669a05
SP
14warn () {
15 echo "$*" >&2
16}
17
6f6826c5
JS
18map()
19{
3520e1e8 20 # if it was not rewritten, take the original
c57a3494
JS
21 if test -r "$workdir/../map/$1"
22 then
23 cat "$workdir/../map/$1"
24 else
25 echo "$1"
26 fi
6f6826c5
JS
27}
28
f95eef15
JS
29# if you run 'skip_commit "$@"' in a commit filter, it will print
30# the (mapped) parents, effectively skipping the commit.
31
32skip_commit()
33{
34 shift;
35 while [ -n "$1" ];
36 do
37 shift;
38 map "$1";
39 shift;
40 done;
41}
42
d3240d93
PH
43# if you run 'git_commit_non_empty_tree "$@"' in a commit filter,
44# it will skip commits that leave the tree untouched, commit the other.
45git_commit_non_empty_tree()
46{
47 if test $# = 3 && test "$1" = $(git rev-parse "$3^{tree}"); then
48 map "$3"
49 else
50 git commit-tree "$@"
51 fi
52}
8c1ce0f4
JS
53# override die(): this version puts in an extra line break, so that
54# the progress is still visible
55
56die()
57{
58 echo >&2
59 echo "$*" >&2
60 exit 1
61}
16ed34ad
JS
62EOF
63)
64
65eval "$functions"
8c1ce0f4 66
6f6826c5
JS
67# When piped a commit, output a script to set the ident of either
68# "author" or "committer
69
70set_ident () {
40a7ce64
JK
71 lid="$(echo "$1" | tr "[A-Z]" "[a-z]")"
72 uid="$(echo "$1" | tr "[a-z]" "[A-Z]")"
6f6826c5
JS
73 pick_id_script='
74 /^'$lid' /{
75 s/'\''/'\''\\'\'\''/g
76 h
77 s/^'$lid' \([^<]*\) <[^>]*> .*$/\1/
78 s/'\''/'\''\'\'\''/g
3addc94a 79 s/.*/GIT_'$uid'_NAME='\''&'\''; export GIT_'$uid'_NAME/p
6f6826c5
JS
80
81 g
82 s/^'$lid' [^<]* <\([^>]*\)> .*$/\1/
83 s/'\''/'\''\'\'\''/g
3addc94a 84 s/.*/GIT_'$uid'_EMAIL='\''&'\''; export GIT_'$uid'_EMAIL/p
6f6826c5
JS
85
86 g
87 s/^'$lid' [^<]* <[^>]*> \(.*\)$/\1/
88 s/'\''/'\''\'\'\''/g
3addc94a 89 s/.*/GIT_'$uid'_DATE='\''&'\''; export GIT_'$uid'_DATE/p
6f6826c5
JS
90
91 q
92 }
93 '
94
95 LANG=C LC_ALL=C sed -ne "$pick_id_script"
96 # Ensure non-empty id name.
3addc94a 97 echo "case \"\$GIT_${uid}_NAME\" in \"\") GIT_${uid}_NAME=\"\${GIT_${uid}_EMAIL%%@*}\" && export GIT_${uid}_NAME;; esac"
6f6826c5
JS
98}
99
83e355a6
MM
100USAGE="[--env-filter <command>] [--tree-filter <command>]
101 [--index-filter <command>] [--parent-filter <command>]
102 [--msg-filter <command>] [--commit-filter <command>]
103 [--tag-name-filter <command>] [--subdirectory-filter <directory>]
104 [--original <namespace>] [-d <directory>] [-f | --force]
105 [<rev-list options>...]"
7e0f1704 106
8f321a39 107OPTIONS_SPEC=
7e0f1704
JS
108. git-sh-setup
109
a4661b01 110if [ "$(is_bare_repository)" = false ]; then
26be15f0 111 git diff-files --ignore-submodules --quiet &&
38762c47 112 git diff-index --cached --quiet HEAD -- ||
46eb449c 113 die "Cannot rewrite branch(es) with a dirty working directory."
a4661b01 114fi
46eb449c 115
6f6826c5 116tempdir=.git-rewrite
6f6826c5
JS
117filter_env=
118filter_tree=
119filter_index=
120filter_parent=
121filter_msg=cat
d3240d93 122filter_commit=
6f6826c5 123filter_tag_name=
685ef546 124filter_subdir=
dfd05e38
JS
125orig_namespace=refs/original/
126force=
d3240d93 127prune_empty=
f2f3a6b8 128remap_to_ancestor=
822f7c73 129while :
6f6826c5
JS
130do
131 case "$1" in
132 --)
133 shift
134 break
135 ;;
dfd05e38
JS
136 --force|-f)
137 shift
138 force=t
139 continue
140 ;;
f2f3a6b8 141 --remap-to-ancestor)
7ec344d8 142 # deprecated ($remap_to_ancestor is set now automatically)
f2f3a6b8
TR
143 shift
144 remap_to_ancestor=t
145 continue
146 ;;
d3240d93
PH
147 --prune-empty)
148 shift
149 prune_empty=t
150 continue
151 ;;
6f6826c5
JS
152 -*)
153 ;;
154 *)
155 break;
156 esac
157
158 # all switches take one argument
159 ARG="$1"
160 case "$#" in 1) usage ;; esac
161 shift
162 OPTARG="$1"
163 shift
164
165 case "$ARG" in
166 -d)
167 tempdir="$OPTARG"
168 ;;
6f6826c5
JS
169 --env-filter)
170 filter_env="$OPTARG"
171 ;;
172 --tree-filter)
173 filter_tree="$OPTARG"
174 ;;
175 --index-filter)
176 filter_index="$OPTARG"
177 ;;
178 --parent-filter)
179 filter_parent="$OPTARG"
180 ;;
181 --msg-filter)
182 filter_msg="$OPTARG"
183 ;;
184 --commit-filter)
16ed34ad 185 filter_commit="$functions; $OPTARG"
6f6826c5
JS
186 ;;
187 --tag-name-filter)
188 filter_tag_name="$OPTARG"
189 ;;
685ef546
JS
190 --subdirectory-filter)
191 filter_subdir="$OPTARG"
f2f3a6b8 192 remap_to_ancestor=t
685ef546 193 ;;
dfd05e38 194 --original)
55ced83d 195 orig_namespace=$(expr "$OPTARG/" : '\(.*[^/]\)/*$')/
dfd05e38 196 ;;
6f6826c5
JS
197 *)
198 usage
199 ;;
200 esac
201done
202
d3240d93
PH
203case "$prune_empty,$filter_commit" in
204,)
205 filter_commit='git commit-tree "$@"';;
206t,)
207 filter_commit="$functions;"' git_commit_non_empty_tree "$@"';;
208,*)
209 ;;
210*)
5da81713 211 die "Cannot set --prune-empty and --commit-filter at the same time"
d3240d93
PH
212esac
213
dfd05e38
JS
214case "$force" in
215t)
216 rm -rf "$tempdir"
217;;
218'')
219 test -d "$tempdir" &&
220 die "$tempdir already exists, please remove it"
221esac
af580e9c 222mkdir -p "$tempdir/t" &&
dfd05e38 223tempdir="$(cd "$tempdir"; pwd)" &&
af580e9c
JS
224cd "$tempdir/t" &&
225workdir="$(pwd)" ||
226die ""
6f6826c5 227
def16e71
BC
228# Remove tempdir on exit
229trap 'cd ../..; rm -rf "$tempdir"' 0
230
88e38808
LN
231ORIG_GIT_DIR="$GIT_DIR"
232ORIG_GIT_WORK_TREE="$GIT_WORK_TREE"
233ORIG_GIT_INDEX_FILE="$GIT_INDEX_FILE"
234GIT_WORK_TREE=.
235export GIT_DIR GIT_WORK_TREE
236
dfd05e38 237# Make sure refs/original is empty
0ea29cce 238git for-each-ref > "$tempdir"/backup-refs || exit
dfd05e38
JS
239while read sha1 type name
240do
241 case "$force,$name" in
242 ,$orig_namespace*)
734cd572
JT
243 die "Cannot create a new backup.
244A previous backup already exists in $orig_namespace
245Force overwriting the backup with -f"
dfd05e38
JS
246 ;;
247 t,$orig_namespace*)
248 git update-ref -d "$name" $sha1
249 ;;
250 esac
251done < "$tempdir"/backup-refs
252
418fa3a5 253# The refs should be updated if their heads were rewritten
0ea29cce
EK
254git rev-parse --no-flags --revs-only --symbolic-full-name \
255 --default HEAD "$@" > "$tempdir"/raw-heads || exit
256sed -e '/^^/d' "$tempdir"/raw-heads >"$tempdir"/heads
dfd05e38
JS
257
258test -s "$tempdir"/heads ||
259 die "Which ref do you want to rewrite?"
260
3addc94a
JS
261GIT_INDEX_FILE="$(pwd)/../index"
262export GIT_INDEX_FILE
6f6826c5 263
af580e9c
JS
264# map old->new commit ids for rewriting parents
265mkdir ../map || die "Could not create map/ directory"
6f6826c5 266
2c1d2d81
TR
267# we need "--" only if there are no path arguments in $@
268nonrevs=$(git rev-parse --no-revs "$@") || exit
7ec344d8
CH
269if test -z "$nonrevs"
270then
271 dashdash=--
272else
273 dashdash=
274 remap_to_ancestor=t
275fi
276
2c1d2d81
TR
277rev_args=$(git rev-parse --revs-only "$@")
278
685ef546
JS
279case "$filter_subdir" in
280"")
2c1d2d81 281 eval set -- "$(git rev-parse --sq --no-revs "$@")"
685ef546
JS
282 ;;
283*)
2c1d2d81
TR
284 eval set -- "$(git rev-parse --sq --no-revs "$@" $dashdash \
285 "$filter_subdir")"
286 ;;
287esac
288
289git rev-list --reverse --topo-order --default HEAD \
290 --parents --simplify-merges $rev_args "$@" > ../revs ||
291 die "Could not get the commits"
9d6f220c 292commits=$(wc -l <../revs | tr -d " ")
6f6826c5
JS
293
294test $commits -eq 0 && die "Found nothing to rewrite"
295
dfd05e38
JS
296# Rewrite the commits
297
d5b0c97d 298git_filter_branch__commit_count=0
813b4734 299while read commit parents; do
d5b0c97d
EN
300 git_filter_branch__commit_count=$(($git_filter_branch__commit_count+1))
301 printf "\rRewrite $commit ($git_filter_branch__commit_count/$commits)"
6f6826c5 302
685ef546
JS
303 case "$filter_subdir" in
304 "")
5be60078 305 git read-tree -i -m $commit
685ef546
JS
306 ;;
307 *)
5b044ac3
JH
308 # The commit may not have the subdirectory at all
309 err=$(git read-tree -i -m $commit:"$filter_subdir" 2>&1) || {
d69da76d 310 if ! git rev-parse -q --verify $commit:"$filter_subdir"
5b044ac3
JH
311 then
312 rm -f "$GIT_INDEX_FILE"
313 else
314 echo >&2 "$err"
315 false
316 fi
317 }
af580e9c 318 esac || die "Could not initialize the index"
6f6826c5 319
3addc94a
JS
320 GIT_COMMIT=$commit
321 export GIT_COMMIT
af580e9c
JS
322 git cat-file commit "$commit" >../commit ||
323 die "Cannot read commit $commit"
6f6826c5 324
8c1ce0f4
JS
325 eval "$(set_ident AUTHOR <../commit)" ||
326 die "setting author failed for commit $commit"
327 eval "$(set_ident COMMITTER <../commit)" ||
328 die "setting committer failed for commit $commit"
329 eval "$filter_env" < /dev/null ||
330 die "env filter failed: $filter_env"
6f6826c5
JS
331
332 if [ "$filter_tree" ]; then
af580e9c
JS
333 git checkout-index -f -u -a ||
334 die "Could not checkout the index"
6f6826c5
JS
335 # files that $commit removed are now still in the working tree;
336 # remove them, else they would be added again
6a589fda 337 git clean -d -q -f -x
8c1ce0f4
JS
338 eval "$filter_tree" < /dev/null ||
339 die "tree filter failed: $filter_tree"
340
1fe32cb9 341 (
03ca8395 342 git diff-index -r --name-only --ignore-submodules $commit &&
1fe32cb9 343 git ls-files --others
0ea29cce
EK
344 ) > "$tempdir"/tree-state || exit
345 git update-index --add --replace --remove --stdin \
346 < "$tempdir"/tree-state || exit
6f6826c5
JS
347 fi
348
8c1ce0f4
JS
349 eval "$filter_index" < /dev/null ||
350 die "index filter failed: $filter_index"
6f6826c5
JS
351
352 parentstr=
813b4734 353 for parent in $parents; do
3520e1e8
JS
354 for reparent in $(map "$parent"); do
355 parentstr="$parentstr -p $reparent"
356 done
6f6826c5
JS
357 done
358 if [ "$filter_parent" ]; then
8c1ce0f4
JS
359 parentstr="$(echo "$parentstr" | eval "$filter_parent")" ||
360 die "parent filter failed: $filter_parent"
6f6826c5
JS
361 fi
362
363 sed -e '1,/^$/d' <../commit | \
8c1ce0f4
JS
364 eval "$filter_msg" > ../message ||
365 die "msg filter failed: $filter_msg"
0906f6e1 366 workdir=$workdir @SHELL_PATH@ -c "$filter_commit" "git commit-tree" \
0ea29cce
EK
367 $(git write-tree) $parentstr < ../message > ../map/$commit ||
368 die "could not write rewritten commit"
6f6826c5
JS
369done <../revs
370
f2f3a6b8
TR
371# If we are filtering for paths, as in the case of a subdirectory
372# filter, it is possible that a specified head is not in the set of
373# rewritten commits, because it was pruned by the revision walker.
374# Ancestor remapping fixes this by mapping these heads to the unique
375# nearest ancestor that survived the pruning.
dfd05e38 376
f2f3a6b8 377if test "$remap_to_ancestor" = t
a0e46390
TR
378then
379 while read ref
dfd05e38 380 do
a0e46390
TR
381 sha1=$(git rev-parse "$ref"^0)
382 test -f "$workdir"/../map/$sha1 && continue
2c1d2d81 383 ancestor=$(git rev-list --simplify-merges -1 "$ref" "$@")
a0e46390
TR
384 test "$ancestor" && echo $(map $ancestor) >> "$workdir"/../map/$sha1
385 done < "$tempdir"/heads
386fi
dfd05e38
JS
387
388# Finally update the refs
389
390_x40='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
391_x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
dfd05e38
JS
392echo
393while read ref
394do
395 # avoid rewriting a ref twice
396 test -f "$orig_namespace$ref" && continue
397
398 sha1=$(git rev-parse "$ref"^0)
399 rewritten=$(map $sha1)
400
401 test $sha1 = "$rewritten" &&
402 warn "WARNING: Ref '$ref' is unchanged" &&
403 continue
404
405 case "$rewritten" in
406 '')
407 echo "Ref '$ref' was deleted"
408 git update-ref -m "filter-branch: delete" -d "$ref" $sha1 ||
409 die "Could not delete $ref"
98409060 410 ;;
dfd05e38
JS
411 $_x40)
412 echo "Ref '$ref' was rewritten"
261044e8
TR
413 if ! git update-ref -m "filter-branch: rewrite" \
414 "$ref" $rewritten $sha1 2>/dev/null; then
415 if test $(git cat-file -t "$ref") = tag; then
416 if test -z "$filter_tag_name"; then
417 warn "WARNING: You said to rewrite tagged commits, but not the corresponding tag."
418 warn "WARNING: Perhaps use '--tag-name-filter cat' to rewrite the tag."
419 fi
420 else
421 die "Could not rewrite $ref"
422 fi
423 fi
98409060 424 ;;
dfd05e38
JS
425 *)
426 # NEEDSWORK: possibly add -Werror, making this an error
427 warn "WARNING: '$ref' was rewritten into multiple commits:"
428 warn "$rewritten"
429 warn "WARNING: Ref '$ref' points to the first one now."
430 rewritten=$(echo "$rewritten" | head -n 1)
431 git update-ref -m "filter-branch: rewrite to first" \
432 "$ref" $rewritten $sha1 ||
433 die "Could not rewrite $ref"
434 ;;
435 esac
0ea29cce
EK
436 git update-ref -m "filter-branch: backup" "$orig_namespace$ref" $sha1 ||
437 exit
dfd05e38
JS
438done < "$tempdir"/heads
439
440# TODO: This should possibly go, with the semantics that all positive given
441# refs are updated, and their original heads stored in refs/original/
442# Filter tags
6f6826c5
JS
443
444if [ "$filter_tag_name" ]; then
5be60078 445 git for-each-ref --format='%(objectname) %(objecttype) %(refname)' refs/tags |
6f6826c5
JS
446 while read sha1 type ref; do
447 ref="${ref#refs/tags/}"
448 # XXX: Rewrite tagged trees as well?
449 if [ "$type" != "commit" -a "$type" != "tag" ]; then
450 continue;
451 fi
452
453 if [ "$type" = "tag" ]; then
454 # Dereference to a commit
455 sha1t="$sha1"
7bd93c1c 456 sha1="$(git rev-parse -q "$sha1"^{commit})" || continue
6f6826c5
JS
457 fi
458
459 [ -f "../map/$sha1" ] || continue
460 new_sha1="$(cat "../map/$sha1")"
3addc94a
JS
461 GIT_COMMIT="$sha1"
462 export GIT_COMMIT
8c1ce0f4
JS
463 new_ref="$(echo "$ref" | eval "$filter_tag_name")" ||
464 die "tag name filter failed: $filter_tag_name"
6f6826c5
JS
465
466 echo "$ref -> $new_ref ($sha1 -> $new_sha1)"
467
468 if [ "$type" = "tag" ]; then
a9da1663
JS
469 new_sha1=$( ( printf 'object %s\ntype commit\ntag %s\n' \
470 "$new_sha1" "$new_ref"
471 git cat-file tag "$ref" |
1bf6551e 472 sed -n \
9524cf29 473 -e '1,/^$/{
a9da1663
JS
474 /^object /d
475 /^type /d
476 /^tag /d
9524cf29 477 }' \
1bf6551e 478 -e '/^-----BEGIN PGP SIGNATURE-----/q' \
a9da1663 479 -e 'p' ) |
1bf6551e
BC
480 git mktag) ||
481 die "Could not create new tag object for $ref"
482 if git cat-file tag "$ref" | \
e1622bfc 483 sane_grep '^-----BEGIN PGP SIGNATURE-----' >/dev/null 2>&1
1bf6551e
BC
484 then
485 warn "gpg signature stripped from tag object $sha1t"
486 fi
6f6826c5
JS
487 fi
488
af580e9c
JS
489 git update-ref "refs/tags/$new_ref" "$new_sha1" ||
490 die "Could not write tag $new_ref"
6f6826c5
JS
491 done
492fi
493
494cd ../..
495rm -rf "$tempdir"
6f6826c5 496
def16e71
BC
497trap - 0
498
9273b562
EK
499unset GIT_DIR GIT_WORK_TREE GIT_INDEX_FILE
500test -z "$ORIG_GIT_DIR" || {
501 GIT_DIR="$ORIG_GIT_DIR" && export GIT_DIR
502}
503test -z "$ORIG_GIT_WORK_TREE" || {
504 GIT_WORK_TREE="$ORIG_GIT_WORK_TREE" &&
505 export GIT_WORK_TREE
506}
507test -z "$ORIG_GIT_INDEX_FILE" || {
508 GIT_INDEX_FILE="$ORIG_GIT_INDEX_FILE" &&
509 export GIT_INDEX_FILE
510}
511
a4661b01 512if [ "$(is_bare_repository)" = false ]; then
0ea29cce 513 git read-tree -u -m HEAD || exit
a4661b01 514fi
46eb449c 515
0ea29cce 516exit 0